import * as react_jsx_runtime from 'react/jsx-runtime';
import { ReactNode, ComponentProps, ComponentType } from 'react';
import { P as PropsWithoutChildren } from './PropsWithoutChildren-B-UcudRB.cjs';

type DelayProps = {
    ms?: number;
    fallback?: never;
    children?: ({ isDelayed }: {
        isDelayed: boolean;
    }) => ReactNode;
} | {
    ms?: number;
    fallback?: ReactNode;
    children?: ReactNode;
};
/**
 * This component delays the rendering of its children for a specified duration.
 *
 * The Delay component provides a way to introduce intentional delays in rendering,
 * which can be useful for loading states or animations.
 * @see {@link https://suspensive.org/docs/react/Delay Suspensive Docs}
 */
declare const Delay: ((props: DelayProps) => react_jsx_runtime.JSX.Element) & {
    displayName: string;
    with: <TProps extends ComponentProps<ComponentType> = Record<string, never>>(delayProps: PropsWithoutChildren<DelayProps> | undefined, Component: ComponentType<TProps>) => ((props: TProps) => react_jsx_runtime.JSX.Element) & {
        displayName: string;
    };
};

export { Delay, type DelayProps };
